#region Using declarations
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Input;
using System.Windows.Media;
using System.Xml.Serialization;
using NinjaTrader.Cbi;
using NinjaTrader.Gui;
using NinjaTrader.Gui.Chart;
using NinjaTrader.Gui.SuperDom;
using NinjaTrader.Gui.Tools;
using NinjaTrader.Data;
using NinjaTrader.NinjaScript;
using NinjaTrader.Core.FloatingPoint;

#endregion



#region NinjaScript generated code. Neither change nor remove.

namespace NinjaTrader.NinjaScript.Indicators
{
	public partial class Indicator : NinjaTrader.Gui.NinjaScript.IndicatorRenderBase
	{
		
		private BuySideGlobal.BSGTrailingStop[] cacheBSGTrailingStop;

		
		public BuySideGlobal.BSGTrailingStop BSGTrailingStop(Brush upcolor1, int alpha, int beta, int gamma, bool colorbar, bool smooth, Brush dncolor1, Brush flatcolor1)
		{
			return BSGTrailingStop(Input, upcolor1, alpha, beta, gamma, colorbar, smooth, dncolor1, flatcolor1);
		}


		
		public BuySideGlobal.BSGTrailingStop BSGTrailingStop(ISeries<double> input, Brush upcolor1, int alpha, int beta, int gamma, bool colorbar, bool smooth, Brush dncolor1, Brush flatcolor1)
		{
			if (cacheBSGTrailingStop != null)
				for (int idx = 0; idx < cacheBSGTrailingStop.Length; idx++)
					if (cacheBSGTrailingStop[idx].upcolor1 == upcolor1 && cacheBSGTrailingStop[idx].alpha == alpha && cacheBSGTrailingStop[idx].beta == beta && cacheBSGTrailingStop[idx].gamma == gamma && cacheBSGTrailingStop[idx].colorbar == colorbar && cacheBSGTrailingStop[idx].smooth == smooth && cacheBSGTrailingStop[idx].dncolor1 == dncolor1 && cacheBSGTrailingStop[idx].flatcolor1 == flatcolor1 && cacheBSGTrailingStop[idx].EqualsInput(input))
						return cacheBSGTrailingStop[idx];
			return CacheIndicator<BuySideGlobal.BSGTrailingStop>(new BuySideGlobal.BSGTrailingStop(){ upcolor1 = upcolor1, alpha = alpha, beta = beta, gamma = gamma, colorbar = colorbar, smooth = smooth, dncolor1 = dncolor1, flatcolor1 = flatcolor1 }, input, ref cacheBSGTrailingStop);
		}

	}
}

namespace NinjaTrader.NinjaScript.MarketAnalyzerColumns
{
	public partial class MarketAnalyzerColumn : MarketAnalyzerColumnBase
	{
		
		public Indicators.BuySideGlobal.BSGTrailingStop BSGTrailingStop(Brush upcolor1, int alpha, int beta, int gamma, bool colorbar, bool smooth, Brush dncolor1, Brush flatcolor1)
		{
			return indicator.BSGTrailingStop(Input, upcolor1, alpha, beta, gamma, colorbar, smooth, dncolor1, flatcolor1);
		}


		
		public Indicators.BuySideGlobal.BSGTrailingStop BSGTrailingStop(ISeries<double> input , Brush upcolor1, int alpha, int beta, int gamma, bool colorbar, bool smooth, Brush dncolor1, Brush flatcolor1)
		{
			return indicator.BSGTrailingStop(input, upcolor1, alpha, beta, gamma, colorbar, smooth, dncolor1, flatcolor1);
		}
	
	}
}

namespace NinjaTrader.NinjaScript.Strategies
{
	public partial class Strategy : NinjaTrader.Gui.NinjaScript.StrategyRenderBase
	{
		
		public Indicators.BuySideGlobal.BSGTrailingStop BSGTrailingStop(Brush upcolor1, int alpha, int beta, int gamma, bool colorbar, bool smooth, Brush dncolor1, Brush flatcolor1)
		{
			return indicator.BSGTrailingStop(Input, upcolor1, alpha, beta, gamma, colorbar, smooth, dncolor1, flatcolor1);
		}


		
		public Indicators.BuySideGlobal.BSGTrailingStop BSGTrailingStop(ISeries<double> input , Brush upcolor1, int alpha, int beta, int gamma, bool colorbar, bool smooth, Brush dncolor1, Brush flatcolor1)
		{
			return indicator.BSGTrailingStop(input, upcolor1, alpha, beta, gamma, colorbar, smooth, dncolor1, flatcolor1);
		}

	}
}

#endregion
